<script setup>
import { useInstrumentStore } from '../stores/instrument.js'

// UI stuff
import { CdxButton } from '@wikimedia/codex';
import { useRouter } from 'vue-router'
import { toast } from 'vue3-toastify';
import 'vue3-toastify/dist/index.css';
import { useCookies} from 'vue3-cookies';

// Import child form components
import Name from './form/Name.vue'
import Details from './form/Details.vue'
import Sampling from './form/Sampling.vue'
import Duration from './form/Duration.vue'
import Variants from './form/Variants.vue'
import Regulation from './form/Regulation.vue'

const { cookies } = useCookies();
const store = useInstrumentStore();
const router = useRouter()

store.formFunction = 'modify';

async function submit() {

    const formData = Object.assign({
        csrf_token: cookies.get('csrf_token'),
    }, store.instrument);

    const response = await store.updateInstrument(formData, 'update-experiment');
    toast(response.data.title, {
        type: response.success ? 'success' : 'error',
        position: 'bottom-right',
        autoClose: 2000,
    });
    if (response.success) {
        const instrumentName = formData.name;
        store.setSuccessMessage(`The A/B test ${instrumentName} has been successfully updated. `);
        // Redirect to the List.vue
        router.push({ name: 'catalog' });
    }
}
</script>

<template>
    <Suspense>
        <div>
            <!-- HEADER -->
            <div class="subheader">
                <h1>Modify A/B test: {{ store.instrument.name }}</h1>
                <div class="subtitle">Use this form to configure your A/B tests and start collecting data.</div>
            </div>

            <div class="body">
                <form @submit.prevent="submit">
                    <!-- GET STARTED SECTION -->
                    <div class="section">
                        <Name />
                    </div>

                    <!-- DETAILS SECTION -->
                    <div class="section">
                        <Details />
                    </div>

                    <!-- Sampling -->
                    <div class="section">
                        <Sampling />
                    </div>

                    <!-- DURATION SECTION -->
                    <div class="section">
                        <Duration />
                    </div>

                    <!-- VARIANTS SECTION -->
                    <div class="section">
                        <Variants />
                    </div>

                    <!-- REGULATION SECTION -->
                    <div class="section">
                        <Regulation />
                    </div>

                    <!-- SUBMIT -->
                    <div class="section-last">
                        <cdx-button action="progressive" weight="primary" data-id="modify-submit">
                            Save configuration
                        </cdx-button>
                    </div>
                </form>
            </div>

        </div>
        <template #fallback>
            <div>Loading...</div>
        </template>
    </Suspense>

</template>
